import * as mc from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui"

mc.world.afterEvents.itemUse.subscribe( data => {
    const item = data.itemStack;
    const player = data.source;
    if (item.typeId == "bg:horseshoe") {
    om_main_interface(player);
    }
});

mc.world.beforeEvents.playerInteractWithEntity.subscribe( data => {
    const entity = data.target;
    const player = data.player;
    let allow = true;
    if (entity.hasTag('om_exclusive2') && !entity.hasTag(`om_${player.id}`)) {
    allow = false;
    let rideable = entity.getComponent('rideable');
    let riders = rideable.getRiders();
    riders.forEach(rider => {
    if (entity.hasTag(`om_${rider.id}`)) {
    allow = true;
       }}
    )}
    if ((entity.hasTag('om_exclusive') && !entity.hasTag(`om_${player.id}`)) || allow == false) {
    data.cancel = true;
    player.sendMessage({translate: "om.exclusive_warn"});
    }
});

mc.system.runInterval(() => {
    let players = mc.world.getAllPlayers();
    players.forEach(player => {
    let mountsSD = player.dimension.getEntities({tags:['om_stay']})
    mountsSD.forEach(mountSD => {
    mountSD.addEffect('slowness', 5, { amplifier: 99, showParticles: false });
    })
    let mountsSM = player.dimension.getEntities({tags:['om_stay2']})
    mountsSM.forEach(mountSM => {
    mountSM.addEffect('slowness', 5, { amplifier: 99, showParticles: false });
    })
    let riding = player.getComponent('riding');
    if (!riding) {
    return;
    }
    let mount = riding.entityRidingOn;
    if (mount.hasTag('om_stay2')) {
    mount.removeTag('om_stay2');
    }
    let allow = true;
    let rideable = mount.getComponent('rideable');
    let riders = rideable.getRiders();
    riders.forEach(rider => {
    if (rider.hasTag('om_exclusive')) {
    allow = false;
    if (rider.hasTag(`om_${player.id}`)) {
    allow = true;
    }} else if (rider.hasTag('om_exclusive2')) {
    allow = false;
    riders.forEach(rider2 => {
    if (rider.hasTag(`om_${rider2.id}`)) {
    allow = true;
          }}
       )}
    });
    if (mount.hasTag('om_exclusive2') && !mount.hasTag(`om_${player.id}`) && allow == true) {
    allow = false;
    riders.forEach(rider3 => {
    if (mount.hasTag(`om_${rider3.id}`)) {
    allow = true;
       }}
    )}
    if (allow == false) {
    rideable.ejectRider(player);
    player.sendMessage({translate: "om.exclusive_warn"});
       }
    })
}, 5);

function om_main_interface(player) {
        const form = new ActionFormData()
            .title({translate: "om.main_interface"})
            .button({translate: "om.binding"})
            .button({translate: "om.exclusivity"})
            .button({translate: "om.utilities"})
        form.show(player).then(r => {
        if (r.selection == 0)  binding(player)
        if (r.selection == 1) exclusivity(player)
        if (r.selection == 2) utilities(player)
   }
)}

function binding(player) {
        const form = new ActionFormData()
            .title({translate: "om.binding"})
            .button({translate: "om.become_owned"})
            .button({translate: "om.not_become_owned"})
            .button({translate: "om.call_owned"})
            .button({translate: "om.back"})
        form.show(player).then(r => {
        if (r.selection == 0)  become_owned(player)
        if (r.selection == 1)  become_not_owned(player)
        if (r.selection == 2) call_owned(player)
        if (r.selection == 3) om_main_interface(player)
   }
)}

function exclusivity(player) {
        const form = new ActionFormData()
            .title({translate: "om.exclusivity"})
            .button({translate: "om.be_exclusive"})
            .button({translate: "om.allow_others"})
            .button({translate: "om.not_be_exclusive"})
            .button({translate: "om.back"})
        form.show(player).then(r => {
        if (r.selection == 0)  become_exclusive(player)
        if (r.selection == 1) allow_others(player)
        if (r.selection == 2) become_not_exclusive(player)
        if (r.selection == 3) om_main_interface(player)
   }
)}

function utilities(player) {
        const form = new ActionFormData()
            .title({translate: "om.utilities"})
            .button({translate: "om.owned_amount"})
            .button({translate: "om.exclusives_amount"})
            .button({translate: "om.stats_riding"})
            .button({translate: "om.stats_owned"})
            .button({translate: "om.stay_until_disable"})
            .button({translate: "om.stay_until_mount"})
            .button({translate: "om.stay_disable"})
            .button({translate: "om.back"})
        form.show(player).then(r => {
        if (r.selection == 0)  owned_amount(player)
        if (r.selection == 1) exclusives_amount(player)
        if (r.selection == 2) stats_riding(player)
        if (r.selection == 3) stats_owned(player)
        if (r.selection == 4) stay_until_disable(player)
        if (r.selection == 5) stay_until_mount(player)
        if (r.selection == 6) stay_disable(player)
        if (r.selection == 7) om_main_interface(player)
   }
)}

function become_owned(player) {
    let riding = player.getComponent('riding');
    if (!riding) {
    return;
    }
    let mount = riding.entityRidingOn;
    if ((mount.hasComponent('minecraft:tameable') && !mount.hasComponent('minecraft:is_tamed')) || ((mount.hasTag('om_exclusive') || mount.hasTag('om_exclusive2') || mount.hasTag('om_owned')) && !mount.hasTag(`om_${player.id}`))) {
    return;
    } else {
    mount.addTag('om_owned');
    mount.addTag(`om_${player.id}`);
    mount.runCommand('tag @s[family=inanimated] remove om_owned');
    mount.runCommand(`tag @s[family=inanimated] remove om_${player.id}`);
}}

function become_not_owned(player) {
    let riding = player.getComponent('riding');
    if (!riding) {
    return;
    }
    let mount = riding.entityRidingOn;
    if (((mount.hasTag('om_exclusive') || mount.hasTag('om_exclusive2') || mount.hasTag('om_owned')) && !mount.hasTag(`om_${player.id}`))) {
    return;
    } else {
    mount.removeTag('om_owned');
    if (!mount.hasTag('om_exclusive') && !mount.hasTag('om_exclusive2')) {
    mount.removeTag(`om_${player.id}`);
    }
}}

function call_owned(player) {
    let mounts = player.dimension.getEntities({tags:['om_owned', `om_${player.id}`], closest: 1})
    mounts.forEach(mount => {
    mount.teleport(player.location);
    }
)}

function become_exclusive(player) {
    let riding = player.getComponent('riding');
    if (!riding) {
    return;
    }
    let mount = riding.entityRidingOn;
    if ((mount.hasComponent('minecraft:tameable') && !mount.hasComponent('minecraft:is_tamed')) || ((mount.hasTag('om_exclusive') || mount.hasTag('om_exclusive2') || mount.hasTag('om_owned')) && !mount.hasTag(`om_${player.id}`))) {
    return;
    } else {
    mount.removeTag('om_exclusive2');
    mount.addTag('om_exclusive');
    mount.addTag(`om_${player.id}`);
    mount.runCommand('tag @s[family=!mob] remove om_exclusive');
    mount.runCommand(`tag @s[family=!mob] remove om_${player.id}`);
}}

function allow_others(player) {
    let riding = player.getComponent('riding');
    if (!riding) {
    return;
    }
    let mount = riding.entityRidingOn;
    if ((mount.hasComponent('minecraft:tameable') && !mount.hasComponent('minecraft:is_tamed')) || ((mount.hasTag('om_exclusive') || mount.hasTag('om_exclusive2') || mount.hasTag('om_owned')) && !mount.hasTag(`om_${player.id}`))) {
    return;
    } else {
    mount.removeTag('om_exclusive');
    mount.addTag('om_exclusive2');
    mount.addTag(`om_${player.id}`);
    mount.runCommand('tag @s[family=!mob] remove om_exclusive2');
    mount.runCommand(`tag @s[family=!mob] remove om_${player.id}`);
}}

function become_not_exclusive(player) {
    let riding = player.getComponent('riding');
    if (!riding) {
    return;
    }
    let mount = riding.entityRidingOn;
    if (((mount.hasTag('om_exclusive') || mount.hasTag('om_exclusive2')) && !mount.hasTag(`om_${player.id}`))) {
    return;
    } else {
    mount.removeTag('om_exclusive');
    mount.removeTag('om_exclusive2');
    if (!mount.hasTag('om_owned')) {
    mount.removeTag(`om_${player.id}`);
    }
}}

function owned_amount(player) {
    let amount = 0;
    let mounts = player.dimension.getEntities({tags:['om_owned', `om_${player.id}`]})
    mounts.forEach(mount => {
    amount += 1;
    })
    player.sendMessage({"rawtext": [{ "translate": "om.mounts_found"},{ "text": `${amount}`}]});
    }

function exclusives_amount(player) {
    let amount = 0;
    let mounts = player.dimension.getEntities({tags:['om_exclusive', `om_${player.id}`]})
    mounts.forEach(mount => {
    amount += 1;
    })
    let mounts2 = player.dimension.getEntities({tags:['om_exclusive2', `om_${player.id}`]})
    mounts2.forEach(mount2 => {
    amount += 1;
    })
    player.sendMessage({"rawtext": [{ "translate": "om.mounts_found"},{ "text": `${amount}`}]});
    }

function stats_riding(player) {
    let mount = player.getComponent('riding').entityRidingOn;
    if (!mount) {
    return;
    }
    let health = mount.getComponent("minecraft:health")
    let healthM = health?.effectiveMax
    let healthC = health?.currentValue
    let loc = mount.location;
    player.sendMessage({translate: "om.mount_stats"});
    if (mount.hasTag('om_owned')) {
    player.sendMessage({translate: "om.owned_true"});
    } else {
    player.sendMessage({translate: "om.owned_false"});
    }
    if (mount.hasTag('om_exclusive')) {
    player.sendMessage({translate: "om.exclusive_true"});
    } else {
    player.sendMessage({translate: "om.exclusive_false"});
    }
    player.sendMessage({"rawtext": [{ "translate": "om.health"},{ "text": `${healthC}/${healthM}`}]});
    player.sendMessage({translate: "om.location"});
    player.sendMessage(`x: ${Math.round(loc.x)}, y: ${Math.round(loc.y)}, z: ${Math.round(loc.z)}`);
}

function stats_owned(player) {
    let mounts = player.dimension.getEntities({tags:['om_owned', `om_${player.id}`], closest: 1})
    mounts.forEach(mount => {
    let health = mount.getComponent("minecraft:health")
    let healthM = health?.effectiveMax
    let healthC = health?.currentValue
    let loc = mount.location;
    player.sendMessage({translate: "om.mount_stats"});
    if (mount.hasTag('om_owned')) {
    player.sendMessage({translate: "om.owned_true"});
    } else {
    player.sendMessage({translate: "om.owned_false"});
    }
    if (mount.hasTag('om_exclusive')) {
    player.sendMessage({translate: "om.exclusive_true"});
    } else {
    player.sendMessage({translate: "om.exclusive_false"});
    }
    player.sendMessage({"rawtext": [{ "translate": "om.health"},{ "text": `${healthC}/${healthM}`}]});
    player.sendMessage({translate: "om.location"});
    player.sendMessage(`x: ${Math.round(loc.x)}, y: ${Math.round(loc.y)}, z: ${Math.round(loc.z)}`);
    }
)}

function stay_until_disable(player) {
    let mount = player.getComponent('riding').entityRidingOn;
    if (!mount) {
    return;
    }
    if (((mount.hasTag('om_exclusive') || mount.hasTag('om_exclusive2') || mount.hasTag('om_owned')) && !mount.hasTag(`om_${player.id}`))) {
    return;
    } else {
    mount.removeTag(`om_stay2`);
    mount.addTag(`om_stay`);
    return;
}}

function stay_until_mount(player) {
    let mount = player.getComponent('riding').entityRidingOn;
    if (!mount) {
    return;
    }
    if (((mount.hasTag('om_exclusive') || mount.hasTag('om_exclusive2') || mount.hasTag('om_owned')) && !mount.hasTag(`om_${player.id}`))) {
    return;
    } else {
    mount.removeTag(`om_stay`);
    mount.addTag(`om_stay2`);
    let rideable = mount.getComponent('rideable');
    let riders = rideable.getRiders();
    riders.forEach(rider => {
    rideable.ejectRider(player);
    })
    return;
}}

function stay_disable(player) {
    let mount = player.getComponent('riding').entityRidingOn;
    if (!mount) {
    return;
    }
    if (((mount.hasTag('om_exclusive') || mount.hasTag('om_exclusive2') || mount.hasTag('om_owned')) && !mount.hasTag(`om_${player.id}`))) {
    return;
    } else {
    mount.removeTag(`om_stay2`);
    mount.removeTag(`om_stay`);
    return;
}}